var extensionId;
var activeTabId;

console.log('loaded ' + Math.floor(Date.now() / 1000));

/////////////////////////////
/////////////////////////////
// Array of login tacker data
////////////////////////////
/////////////////////////////
function loginPage(tabId, url) {
    this.id = tabId;
    this.url = url;
}

function LoginManager() {
    this.arr = [];

}

LoginManager.prototype.add = function(tabId, url) {

    this.arr.push(new loginPage(tabId, url));
}

LoginManager.prototype.contains = function(tabId, url) {
    for (var x = 0; x < this.arr.length; x++) {
        // compare to make sure control has
        // the value that was set. If not
        // return so we can wait
        if (tabId === this.arr[x].id) {
            if (url === this.arr[x].url)
                return true;
        }
    }

    return false;
}

LoginManager.prototype.remove = function(tabId) {
    for (var x = 0; x < this.arr.length; x++) {
        // compare to make sure control has
        // the value that was set. If not
        // return so we can wait
        if (tabId === this.arr[x].id) {
            delete this.arr[x];
        }
    }
};

var loginData = new LoginManager();


/////////////////////////////
/////////////////////////////
// Array of pages where
// login has been executed
/////////////////////////////
/////////////////////////////
function Sites() {
    this.arr = [];
    this.key = null;
}


Sites.prototype.contains = function(url) {
    for (var x = 0; x < this.arr.length; x++) {
        // compare to make sure control has
        // the value that was set. If not
        // return so we can wait
        if (url === this.arr[x])
            return true;
    }

    return false;
}

Sites.prototype.add = function(url) {
    if (this.contains(url))
        return;

    this.arr.push(url);
}


/////////////////////////////
/////////////////////////////
// Page submit tracker
// Note: prevents double 
// submission if login fails
/////////////////////////////
/////////////////////////////

function SessionLoginManager() {
    this.sitePages = {};
}

SessionLoginManager.prototype.get = function(tabId) {
    return this.sitePages[tabId];
};

SessionLoginManager.prototype.add = function(tabId, url) {

    var theSiteObj = this.get(tabId);
    if (theSiteObj === undefined || theSiteObj === null) {
        var site = new Sites();
        site.arr.push(url);
        this.sitePages[tabId] = site;
    } else {
        if (!theSiteObj.contains(url)) {
            theSiteObj.add(url);
        }
    }
}

SessionLoginManager.prototype.remove = function(tabId) {
    delete this.sitePages[tabId];
};

var sessionLoginManager = new SessionLoginManager();


function TabManager() {

    var tabs = {};

    this.push = function(t, j) {
        tabs[t] = j;
    };

    this.get = function(t) {
        return tabs[t];
    };

    this.remove = function(t) {
        delete tabs[t];
    };

    this.clear = function() {
        tabs = {};
    };

    this.tabs = function() {
        return tabs;
    };

    this.getPortalTabId = function() {
        var idFound = null;
        $j.each(tabs, function() {
            if ('undefined' !== typeof(this.portalPageTabId)) {
                idFound = this.portalPageTabId;
            };
        });
        return idFound;
    };

}

var tabManager = new TabManager();


// map of tab id point to login object
// mapLoginObjects[tabid] = json object
var mapLoginObjects = new Object();

function getLoginObjectFromTabId(k) {
    return mapLoginObjects[k];
}


// map of tab id point to login object
// mapLoginSuccess[tabid] = true/false
var mapLoginSuccess = new Object();

function getLoginStateFromTab(k) {
    return mapLoginSuccess[k];
}

getBrowser();
if ("undefined" === typeof safariStartupFlag && browserType === browserEnum.EDGE) {
    browser.tabs.onRemoved.addListener(function(tabId, removeInfo) {
        var state = getLoginStateFromTab(tabId);
        if ("undefined" !== typeof state) {
            if (debug) console.log("Tab closing deleting tab id " + tabId + " from the logged in map");
        }

    });

} else if ("undefined" === typeof safariStartupFlag && browserType !== browserEnum.EDGE) {
    chrome.tabs.onRemoved.addListener(function(tabId, removeInfo) {
        var state = getLoginStateFromTab(tabId);
        if ("undefined" !== typeof state) {
            if (debug) console.log("Tab closing deleting tab id " + tabId + " from the logged in map");
        }
    });
    // TODO this can be removed when done with dev of AGNT-90 desktop icon sso
    chrome.tabs.onActivated.addListener(function(activeInfo) {
        activeTabId = activeInfo.tabId;
    });
} else {
    // this is safari support
    safari.application.addEventListener('close', function(e) {
        if (e.target instanceof SafariBrowserTab) {

            if ("undefined" !== typeof e.target.avatierId) {
                if (debug) console.log("Tab closing deleting tab id " + e.target.avatierId + " from the logged in map");

            }
        }


    }, true);


    safari.application.addEventListener('open', function(e) {
        if (e.target instanceof SafariBrowserTab) {

            if ("undefined" !== typeof e.target.avatierId) {
                if (debug) console.log("Tab opening tab id " + e.target.avatierId + " from the logged in map");

            }
        }


    }, true);


}

function backgroundMessageProcessor(message, sender, sendResponse) {
    if (debug) console.log("received background message");

    if (message.method === 'addSubmittedPage') {

        if (debug) console.log("addSubmittedPage message received");
        var url = message.href;
        var pageId = message.pageKey;
        var tabId = sender.tab.id;

        sessionLoginManager.add(tabId, url);

    } else if (message.method === 'getClipboard') {

        console.log("frame or url loaded. HREF = " + message.href);

    } else if (message.method === 'setClipboard') {

        console.log("frame or url loaded. HREF = " + message.href);

    } else if (message.method === 'loginPage') {

        if (debug) console.log("loginPage message received");

        var url = message.href;
        var tabId = sender.tab.id;

        loginData.add(tabId, url);

        console.log("received login page for tab = " + tabId + "  and url = " + url);

    } else if (message.method === 'getRedirectSignatureId') {

        if (debug) console.log("getRedirectSignatureId message received");

    } else if (message.method === 'store') {

        if (debug) console.log("store message received");

    } else if (message.method === 'lid') {

        if (debug) console.log("lid message received");
        HandleAppNavigation(message.data);

    } else if (message.method === 'lid_current') {
        
        if (debug) console.log("lid_current message received");
        HandleAppNavigationCurrent(message.data);

    } else if (message.method === 'clearLocalMultiform') {

        if (debug) console.log("clearLocalMultiform message received");
        HandleClearMultiform();
        sendResponse({ farewell: "remove banner" });

    } else if (message.method === 'portalPhoneHome') {
        if (debug) console.log("portalPhoneHome message received");
        HandlePhoneHomeMessage();
        sendResponse();

    } else if (message.method === 'StartAppLogin') {

        if (debug) console.log("StartAppLogin message received from AVATIER extension page");
        if (debug) console.log(sender.tab ?
            "from a content script:" + sender.tab.url + "  tab id: " + sender.tab.id :
            "from the extension");

        var targetPage;

        if (browserType === browserEnum.EDGE) {
            targetPage = browser.extension.getURL("avatier_connecting.html");
        } else {
            targetPage = chrome.extension.getURL("avatier_connecting.html");
        }

        if (sender.tab.url === targetPage) {
            HandleAppLogin(sender.tab.id);
        }


        sendResponse({ version: 1.0 });

    } else {
        if (debug) console.log("undefined background message received");
    }
}

/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
// Messages from content scripts
/////////////////////////////////////////////////////
/////////////////////////////////////////////////////
if ("undefined" === typeof safariStartupFlag && browserType === browserEnum.EDGE) {
    /////////////////////////////////
    // Edge messages
    /////////////////////////////////
    window.addEventListener("load", function() {
        browser.runtime.onMessage.addListener(backgroundMessageProcessor);
    }, true);

} else if ("undefined" === typeof safariStartupFlag && browserType !== browserEnum.EDGE) {

    /////////////////////////////////
    // Firefox amnd Chrome messages
    /////////////////////////////////
    extensionId = chrome.i18n.getMessage("@@extension_id");
    chrome.runtime.onMessage.addListener(backgroundMessageProcessor);

} else {

    // Safari Messages
    //$j(document).ready(function() {

    if (debug) console.log('Safari extension background loaded');

    safari.application.addEventListener("message", function(event) {

        var request = event.message;

        if (request.method === 'portalPhoneHome') {

            if (debug) console.log("portalPhoneHome message received");
            HandlePhoneHomeMessage();

        } else if (request.method === 'clearLocalMultiform') {

            if (debug) console.log("clearLocalMultiform message received");
            HandleClearMultiform();

        } else if (request.method === 'lid') {
            if (debug) console.log("lid message received");
            HandleAppNavigation(request.data);

        } else if (request.method === 'StartAppLogin') {

            if (debug) console.log("StartAppLogin message received from AVATIER extension page");

            var targetPage = safari.extension.baseURI + "avatier_connecting.html";

            if (event.target.url === targetPage) {
                HandleAppLogin(event.target.avatierId);
            }

        } else if (request.method === 'rfl') {
            // rfl = Return Login Data
            if ("undefined" !== typeof event.target.loginData) {
                if (debug) console.log("rfl href = " + request.url + "  rcv = " + JSON.stringify(event.target.loginData));
                var j = event.target.loginData;

                if (null !== j) {
                    // save data for all tabs
                    savedGlobalLoginData = j;
                    if (debug) console.log("RFL message received!!! Send login data for app login (>>>AvatierSsoLRD<<< message for Safari) url = " + request.url);
                    event.target.page.dispatchMessage('message', j);
                }
            }
        }

    }, false);
    //});
}


function getClipboard() {
    var result = null;
    var textarea = document.getElementById('ta');
    textarea.value = '';
    textarea.select();

    if (document.execCommand('paste')) {
        result = textarea.value;
    } else {
        console.error('failed to get clipboard content');
    }

    textarea.value = '';
    return result;
}

function setClipboard(value) {
    var result = false;
    var textarea = document.getElementById('ta');
    textarea.value = value;
    textarea.select();

    if (document.execCommand('copy')) {
        result = true;
    } else {
        console.error('failed to get clipboard content');
    }

    textarea.value = '';
    return result;
}

function getTabAndUpdate(requestData) {
    if ("undefined" === typeof safariStartupFlag && browserType === browserEnum.EDGE) {
        browser.tabs.query({ active: true, currentWindow: true }, function (arrayOfTabs) {
            mapLoginObjects[arrayOfTabs[0].id] = requestData;
            browser.tabs.update(arrayOfTabs[0].id, {
                url: browser.extension.getURL("avatier_connecting.html")
            });
        });
    } else if ("undefined" === typeof safariStartupFlag && browserType !== browserEnum.EDGE) {
        chrome.tabs.query({ active: true, currentWindow: true }, function (arrayOfTabs) {
            let tab = arrayOfTabs[0];
            if (tab) {
                const tabId = tab.id;
                mapLoginObjects[tabId] = requestData;
                chrome.tabs.update(tabId, {
                    url: chrome.extension.getURL("avatier_connecting.html")
                });
            } else {
                chrome.tabs.get(activeTabId, function (tab) {
                    const tabId = tab.id;
                    mapLoginObjects[tabId] = requestData;
                    chrome.tabs.update(tabId, {
                        url: chrome.extension.getURL("avatier_connecting.html")
                    });
                });
            }
        });
    }
}

function HandlePhoneHomeMessage() {

    if ("undefined" === typeof safariStartupFlag && browserType === browserEnum.EDGE) {
        //ET Phone home for Portal page , sends tab id back top background for sending messages for gfs request
        browser.tabs.query({ active: true, currentWindow: true }, function (arrayOfTabs) {
            // Save the portal tab
            tabManager.push(arrayOfTabs[0].id, { "portalPageTabId": arrayOfTabs[0].id });
        });

    } else if ("undefined" === typeof safariStartupFlag && browserType !== browserEnum.EDGE) {
        //ET Phone home for Portal page , sends tab id back top background for sending messages for gfs request
        chrome.tabs.query({ active: true, currentWindow: true }, function (arrayOfTabs) {
            let tab = arrayOfTabs[0];
            if (tab) {
                tabManager.push(tab.id, { "portalPageTabId": tab.id });
            } else {
                chrome.tabs.get(activeTabId, function (tab) {
                    if (tab) {
                        tabManager.push(tab.id, { "portalPageTabId": tab.id });
                    }
                });
            }
        });
    } else {

        var tab = safari.application.activeBrowserWindow.activeTab;
        if ("undefined" === typeof tab.avatierId) {
            tab.avatierId = guid();
            tabManager.push(tab.avatierId, { "portalPageTabId": tab.avatierId });
        } else {
            if (debug) console.log(tab.avatierId + ' has already been generated. This is probably a frame');
        }
    }

}

function HandleClearMultiform() {

}

function HandleAppLogin(tabId) {
    var newTabId = tabId;

    var requestData = getLoginObjectFromTabId(newTabId);
    if ("undefined" === typeof requestData) {
        if (debugAppNavigation) console.log("UNKNOWN TAB ID... UNABLE TO GET REQUEST DATA");
        return;
    }

    console.log("request data - " + JSON.stringify(requestData))


    var login = new LoginEngine();

    console.log("about to clean")
    var pData = login.clean(requestData, true);
    console.log("after clean")

    //if (debugAppNavigation) console.log("Nav url = " + pData.Href + "   Login data (after clean) = " + JSON.stringify(pData));


    if ("2" == requestData.sigType) {
        // get a clean completed then set the u & p into the ajax call to check for access.

        var url = pData.Href.replace('//', '//' + encodeURIComponent(pData.UserName.v) + ":" + encodeURIComponent(pData.Password.v) + "@");
        pData.Href = url;
    }
    /*
        /// FOR STAPLES ONLY
        if(pData.Href.indexOf('login.staples.com/easylogin/logon') !== -1){
            pData.Href = 'https://login.staples.com/easylogin/logon?TYPE=100663296&REALMOID=06-000b2809-53f6-130b-a253-65540a0420ed&GUID=1&SMAUTHREASON=0&METHOD=GET&SMAGENTNAME=-SM-%2fA83qzHvBljKGuO2%2fGXD9dDvdmjQx2BvESUhLZPWF2L1bE9rlhyenavy8GYtcU7%2b%2fGUaxc6BRYn%2byMX23FyagCksxQdewNoskT7BcWPxRMA0a0Bz3sWmV73MTe9SaDME&TARGET=-SM-HTTPS%3a%2f%2fwww%2estaples%2ecom%2foffice%2fsupplies%2flogin%3fWcUseHttps%3dtrue%26langId%3d--1%26storeId%3d10001%26catalogId%3d10051%26jumpUrl%3dhttp%3a%2f%2fwww%2estaples%2ecom%2f';
        }

        // For BITDEFENDER
        if(pData.Href.indexOf('login.bitdefender.net')  !== -1) {
            pData.Href = 'https://login.bitdefender.net/central/index.html?redirect_url=https:%2F%2Fcentral.bitdefender.com%2F&lang=en_US';
        }
    */

    /*
        if(pData.Href.indexOf('www.egnyte.com/login') !== -1){
            pData.Href = 'https://gigasoft.egnyte.com/#login';
        }
    */

    /*
        if (browserType === browserEnum.EDGE) {

            // Edge is really messed up yet. This
            // should be a tab object, instead we
            // get an ID. Documentation is messed up
            // or the m$ browser
            chrome.tabs.update(newTabId, {url: pData.Href},
                function (tabObj) {


                    StartAppLoginProcess(newTabId, requestData);
                    delete mapLoginObjects[newTabId];
                }
            );

        }else
        */
    if (browserType === browserEnum.SAFARI) {

        // Update tab url
        var targetTab = SafariGetTab(newTabId);
        if ("undefined" !== typeof targetTab) {

            if (targetTab !== null) {

                //targetTab.url = pData.Href;
                safari.application.activeBrowserWindow.activeTab.url = pData.Href;
                if ("undefined" !== typeof targetTab.avatierId) {
                    if (targetTab.avatierId === newTabId) {
                        var requestData = getLoginObjectFromTabId(newTabId);
                        if ("undefined" !== typeof requestData) {
                            if (debugAppNavigation) console.log("Update returning tab id of  " + newTabId);
                            StartAppLoginProcess(newTabId, requestData);
                            //delete mapLoginObjects[newTabId];
                            return;
                        }
                    }
                }
            }
        }

    } else {

        if (debugAppNavigation) console.log("About to update tab with url " + pData.Href);
        if (browserType === browserEnum.EDGE) {

            browser.tabs.update(newTabId, { url: pData.Href },
                function(t) {
                    var requestData = getLoginObjectFromTabId(newTabId);
                    if ("undefined" !== typeof requestData) {
                        if (debugAppNavigation) console.log("Update returning tab id of  " + newTabId);
                        StartAppLoginProcess(t.id, requestData);
                        delete mapLoginObjects[t.id];
                    }
                });
        } else {
            chrome.tabs.update(newTabId, { url: pData.Href },
                function(t) {
                    var requestData = getLoginObjectFromTabId(newTabId);
                    if ("undefined" !== typeof requestData) {
                        if (debugAppNavigation) console.log("Update returning tab id of  " + newTabId);
                        StartAppLoginProcess(newTabId, requestData);
                        delete mapLoginObjects[newTabId];
                    }
                });

        }
    }

}

function HandleAppNavigationCurrent(requestData) {

    requestData.currentTab = true;

    // for NEW navigation

    // sigs with no nsi will fall into the else if portion of the following code, the page will send a message on load, however since
    // the tabs nsi will contain a 0 from the initial gfs, the next message will be ignored by the background because the
    // nsi is set to 0 and nsi is not null.

    //set nsi, check
    var nsi;

    // NOTE {tom}: this has to change. This is really ugly
    try {
        nsi = tabManager.get(requestData.targetTab.id).nsi;
    } catch (e) {
        if (debug) console.log("expected exception in lid handler. Exception = " + e);
        nsi = null;
        // Layer Test NSI needs to be set to trigger GFS proper flow
        if ("undefined" !== typeof(requestData.targetTab)) {

            if ('undefined' !== typeof(requestData.layerTest)) {
                if ('undefined' !== typeof(requestData.layerTest.Key)) {
                    if (null !== requestData.nsi) {
                        nsi = requestData.nsi
                    }
                }
            }
        }
    }

    if (null !== nsi && nsi > 0) {

        // TODO?????????????????? multi form
        this.gfs(request.targetTab, requestData.ntkylf, nsi, requestData.portalURL);

    } else if (null === nsi) {

        if (debugAppNavigation) console.log("going to override current window with avatier_connecting.html");

        console.log("HandleAppNavigationCurrent inside");
        getTabAndUpdate(requestData);

    } else if (-1 === nsi) {
        // BJS - Final page of a login (single or multi) - on load the page sends back the -1 to indicate it has no
        // further nsi chain to process. This space if used for clean up and post processing of a multi-form

    } // if inside request.lid check
}

function HandleAppNavigation(requestData) {
    // for NEW navigation

    // sigs with no nsi will fall into the else if portion of the following code, the page will send a message on load, however since
    // the tabs nsi will contain a 0 from the initial gfs, the next message will be ignored by the background because the
    // nsi is set to 0 and nsi is not null.

    //set nsi, check
    var nsi;

    // NOTE {tom}: this has to change. This is really ugly
    try {
        nsi = tabManager.get(requestData.targetTab.id).nsi;
    } catch (e) {
        if (debug) console.log("expected exception in lid handler. Exception = " + e);
        nsi = null;
        // Layer Test NSI needs to be set to trigger GFS proper flow
        if ("undefined" !== typeof(requestData.targetTab)) {

            if ('undefined' !== typeof(requestData.layerTest)) {
                if ('undefined' !== typeof(requestData.layerTest.Key)) {
                    if (null !== requestData.nsi) {
                        nsi = requestData.nsi
                    }
                }
            }
        }
    }


    if (null !== nsi && nsi > 0) {

        this.gfs(request.targetTab, requestData.ntkylf, nsi, requestData.portalURL);

    } else if (null === nsi) {
        if (debugAppNavigation) console.log("going to open new tab with avatier_connecting.html");

        if (browserType === browserEnum.SAFARI) {
            var newTab = safari.application.activeBrowserWindow.openTab();
            newTab.url = safari.extension.baseURI + "avatier_connecting.html";
            newTab.avatierId = guid();
            newTab.loginTab = true;

            mapLoginObjects[newTab.avatierId] = requestData;


        } else if (browserType === browserEnum.EDGE) {

            browser.tabs.create({
                    'url': browser.extension.getURL("avatier_connecting.html"),
                    'active': true
                },
                function(tab) {

                    // We are going to save the
                    // tab id with the login infor
                    var theTabId = tab.id;
                    mapLoginObjects[theTabId] = requestData;
                });

        } else {

            chrome.tabs.create({
                    'url': chrome.extension.getURL("avatier_connecting.html"),
                    'active': true
                },
                function(tab) {

                    // We are going to save the
                    // tab id with the login infor
                    var theTabId = tab.id;
                    mapLoginObjects[theTabId] = requestData;
                });

        }

    } else if (-1 === nsi) {
        // BJS - Final page of a login (single or multi) - on load the page sends back the -1 to indicate it has no
        // further nsi chain to process. This space if used for clean up and post processing of a multi-form






    } // if inside request.lid check

}


function StartAppLoginProcess(tempTabId, data, forcemulti) {

    var multi = false;
    // set nsi if one exists
    var theTabId = tempTabId;

    if ('undefined' !== data.nsi && data.nsi > 0)

    {

        tabManager.push(theTabId, { "nsi": data.nsi });
        multi = true;

    } else {

        tabManager.push(theTabId, { "nsi": -1 });

    }

    // BJS - Set multi in DATA: Use case is for last sig in chain, its still is a multi, so we need
    // to abort the tests
    data.multi = (forcemulti) ? forcemulti : multi;

    if (browserType === browserEnum.SAFARI) {

        safari.application.addEventListener("navigate", SafariAppLoginEvent, false);

    } else {

        if (browserType === browserEnum.EDGE) {
            browser.tabs.onUpdated.addListener(
                function(tabId, info) {
                    if (tabId === theTabId && info.status === "complete") {

                        var state = getLoginStateFromTab(tabId);
                        //alert(state)
                        if ("undefined" !== typeof state) {
                            if (debugAppNavigation) console.log("Do not attempt login. We are already logged in");
                        } else {
                            setTimeout(function() {
                                AppLogin(tabId, data);
                            }, 500);
                        }
                    }
                });

        } else {
            chrome.tabs.onUpdated.addListener(
                function(tabId, info) {
                    if (tabId === theTabId && info.status === "complete") {
                        var state = getLoginStateFromTab(tabId);
                        //alert(state)
                        if ("undefined" !== typeof state) {
                            if (debugAppNavigation) console.log("Do not attempt login. We are already logged in");
                        } else {
                            setTimeout(function() {
                                AppLogin(tabId, data);
                            }, 500);
                        }
                    }
                });

        }
    }
}


function SafariAppLoginEvent(e) {

    if (e.target instanceof SafariBrowserTab) {

        if ("undefined" !== typeof e.target.avatierId && "undefined" !== typeof e.target.loginTab) {

            if (e.target.loginTab) {

                e.target.loginTab = false;

                var data = getLoginObjectFromTabId(e.target.avatierId);
                if ("undefined" === data) {
                    // no login data
                    if (debug) console.log("NO Data for login = " + data);
                } else {
                    // DO login
                    AppLogin(e.target.avatierId, data);
                    // remove object
                    delete mapLoginObjects[e.target.avatierId];
                }

                //remove tab event
                setTimeout(function() {
                    e.target.removeEventListener('navigate', SafariAppLoginEvent, false);
                }, 50);
            }


        }
    }

}

function SafariGetTab(id) {

    for (var windowIndex = 0; windowIndex < safari.application.browserWindows.length; windowIndex++) {
        for (var tabIndex = 0; tabIndex < safari.application.browserWindows[windowIndex].tabs.length; tabIndex++) {

            var tab = safari.application.browserWindows[windowIndex].tabs[tabIndex];
            if ("undefined" !== typeof tab.avatierId) {
                if (tab.avatierId === id) {
                    return tab;
                }
            }
        }
    }

    return null;
}

function AppLogin(tabId, data) {
    if (debugAppNavigation) console.log("Logging into a frame or the top level documemt on tab.  Tab id = " + tabId);


    if (browserType === browserEnum.SAFARI) {

        var tab = SafariGetTab(tabId);
        if ("undefined" !== typeof tab) {
            if (tab) {
                if (debugAppNavigation) console.log("Saving app login data for tab.  Tab id = " + tabId + "  data obj " + data);

                /*
                var j = {method: "AvatierSsoLRD", data: data}
                tab.page.dispatchMessage('message', j);
                */

                // Safari has some different behavior for loading content scripts.
                //
                // Setup tab with data. We are storing the login information
                // in a tab variable, because we need to wait for the ta
                tab.loginData = { method: "AvatierSsoLRD", data: data };
            }
        }


    } else {
        var arrOfData = ['nothing-yet'];
        var siteData = sessionLoginManager.get(tabId);
        if (siteData === undefined || siteData === null) {
            arrOfData = ['nothing-yet'];
        } else {
            arrOfData = siteData.arr;
        }

        var strArray = arrOfData.toString();

        if (browserType === browserEnum.EDGE) {
            browser.tabs.sendMessage(tabId, { method: "AvatierSsoLRD", data: data, sites: strArray, previousLoginPages: JSON.stringify(loginData.arr) },
                function(response) {
                    if (debugAppNavigation) console.log('App login reponse received: ' + JSON.stringify(response));

                    if (typeof response === 'undefined') {
                        if (debugAppNavigation) console.log("App login response UNKNOWN (probably app login page not initialzed");
                    } else if (response.received) {
                        if (debugAppNavigation) console.log("App login SUCCEEDED");
                        mapLoginSuccess[tabId] = true;
                    } else {
                        if (debugAppNavigation) console.log("App login FAILED");
                    }
                });
        } else {
            chrome.tabs.sendMessage(tabId, { method: "AvatierSsoLRD", data: data, sites: strArray, previousLoginPages: JSON.stringify(loginData.arr) },
                function(response) {
                    if (debugAppNavigation) console.log('App login reponse received: ' + JSON.stringify(response));
                });

        }
    }
}


function remove(arr, item) {
    for (var i = arr.length; i--;) {
        if (arr[i] === item) {
            arr.splice(i, 1);
            break;
        }
    }
}